/* http sample program */
#include <mes2.h>
#include <h8/reg3067.h>
#include <string.h>

//PA0 -> Clk 0->174HC163
//PA1 -> UP(_)
//PA2 -> LDH(_)
//PA3 -> LDL
//PA4 -> PRG_CE
//PA5 -> PRG_WE
//PA6 -> CHR_CE
//PA7 -> CHR_WE

//P50 -> (IN)break{^(0ŃvOI)
//P51 -> (OUT)CLK_FC FCJ[gbWւ̃NbNo

//P40-P47 -> (I/O)DATA(8bit)

//PRG_CECHR_CE𓯎0ɂĂ͂Ȃ
//LDLLDH𓯎0ɂ̂OK
//UP̂ݐ_Ȃ̂Œ


void DoClock();
void CountUP();
void SetData(unsigned char v);
void SetAddr(unsigned short ad);
unsigned char ReadPrg();
unsigned char ReadChr();
int SaveROM(int mapper,int hv);
void WritePrg(unsigned short ad,unsigned char value);
void WriteChr(unsigned short ad,unsigned char value);
void SavePROM(int fd,unsigned char* dram);
void SaveCROM(int fd,unsigned char* dram);
void DoFCClock();
void WritePrgWithConflict(unsigned char value);


int main(int argc, char **argv)
{
	int qflag;
	int n;
	int i;
	int fd,filesize,size;
	unsigned char bv;
	unsigned char	*data;
	int smd;
    volatile unsigned char *smp;
    int mapper,hv;
        
	PADDR=0xff;	//PortA͑Sďo
	P5DDR=P5DDR & 0xfe;
	//P5DDR=P5DDR | 2;
	PADR=0xFD;
	P4DDR=0;	//Port4͍ŏ͓

	//L̐ݒ
	smd=shm_get('NESC',8);
	smp=shm_at(smd);
	smp[0]='s';	//no rom or ǂݍ݊
	
	sleep(300);
	printf("ROMD running..\n");
	while(1){
		while(smp[0]=='s'){
			sleep(300);	//300ms
			if ((P5DR & 1)==0){
				printf("\r\nExit:rom.elf\r\n");
				exit();
			}
		}
		mapper=smp[1];
		hv=smp[2];
		printf("\nstart reading MAPPER=%d HV=%d\r\n",mapper,hv);
		sleep(5000);	//5s
		if (SaveROM(mapper,hv)==0){
			smp[0]='s';	//success
			printf("success\r\n");
		}else{
			smp[0]=='f';	//fail
			printf("fail\r\n");
		}
	}
}

int SaveROM(int mapper,int hv)
{
	unsigned char* dram;
	int	i,j;
	int fd,p_numbank,c_numbank;
    
    //DeleteFile("/ram0/rom.nes");
	fd=open("/ram0/rom.nes",OptWrite);
	if (fd==-1) return fd;
	 
	dram=malloc(0x4000);
	if (dram==-1) return dram;
        
	p_numbank=2;	//16kb*2
	switch(mapper){
		case 0:
	        c_numbank=1;	//8kb*1
	        break;
		case 2:
			p_numbank=8;
			break;
		case 3:
			c_numbank=4;
			break;
	}
        
	for(i=0;i<16;i++){dram[i]=0;}
	
	dram[0]='N';
	dram[1]='E';
	dram[2]='S';
	dram[3]=26;
	dram[4]=p_numbank;
	dram[5]=c_numbank;
	dram[6]=(mapper & 0x0f)<<4 | hv;
	dram[7]=(mapper & 0xf0);
	write(fd,dram,16);

	switch(mapper){
	case 0:
		SetAddr(0);
		for(j=0;j<p_numbank;j++){
			SavePROM(fd,dram);
		}
		SetAddr(0);
		for(j=0;j<c_numbank;j++){
	       	SaveCROM(fd,dram);
		}
		break;
	case 2:	//UNROM
		for(j=0;j<p_numbank;j++){
			WritePrgWithConflict(j);
			SetAddr(0);
			SavePROM(fd,dram);
		}
		break;
	case 3:	//CNROM
		SetAddr(0);
		for(j=0;j<p_numbank;j++){
			SavePROM(fd,dram);
		}
		for(j=0;j<c_numbank;j++){
			WritePrgWithConflict(j);
			SetAddr(0);
			SaveCROM(fd,dram);
		}
		break;
	default:
		close(fd);
		free(dram);
		return 1;
	}
	
	close(fd);
	free(dram);
	return 0;
}
void SavePROM(int fd,unsigned char* dram)
{
	int i;
	for(i=0;i<0x4000;i++){
		dram[i]=ReadPrg();
		CountUP();
	}
	 write(fd,dram,0x4000);

}
void SaveCROM(int fd,unsigned char* dram)
{
	int i;
	for(i=0;i<0x2000;i++){
		dram[i]=ReadChr();
		CountUP();
	}
	write(fd,dram,0x2000);
}

void DoClock()
{
	//PADR=PADR | 1;
	PADR=PADR & 254;
	PADR=PADR | 1;
}
void DoFCClock()
{
	P5DR=P5DR & 0xfd;
	P5DR=P5DR | 2;
}

void CountUP()
{
	PADR=0xff;
	DoClock();
}
void SetData(unsigned char v)
{
	PADR=PADR | 0xf0;
	P4DDR=255;
	P4DR=v;
}
void SetAddr(unsigned short ad)
{
	SetData(ad>>8);
	PADR=0xf9;
	DoClock();
	SetData(ad & 0xff);
	PADR=0xf5;
	DoClock();
}
unsigned char ReadPrg()
{
	unsigned char a;

	P4DDR=0;
	PADR=0xED;
	a=P4DR;
	PADR=0xFD;
	return(a);
}
unsigned char ReadChr()
{
	unsigned char a;

	P4DDR=0;
	PADR=0xBD;
	a=P4DR;
	PADR=0xFD;
	return(a);
}

void WritePrg(unsigned short ad,unsigned char value)
{
	SetAddr(ad);
	P4DDR=0xff;
	P4DR=value;
	//PADR=0xcd;
	//PADR=0xed;
	PADR=0xcd;
	PADR=0xFD;
}
void WriteChr(unsigned short ad,unsigned char value)
{
	SetAddr(ad);
	P4DDR=0xff;
	P4DR=value;
	PADR=0x3d;
	PADR=0xbd;
	PADR=0xFD;
}

void WritePrgWithConflict(unsigned char value)
{
	int i;
	SetAddr(0);
	for(i=0;i<0x3fff;i++){
		if (ReadPrg() == value){
			WritePrg(i,value);
			return;
		}
		CountUP();
	}
	WritePrg(0,value);
}

